package com.huimv.eartag2.process2.controller;

import com.huimv.eartag2.common.utils.BizConst;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.TimeUnit;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@RestController
@RequestMapping("/redis")
public class RedisContrller {
    @Resource
    private RedisTemplate redisTemplate;

    @RequestMapping(value = "/set",method = RequestMethod.GET)
    public void set1(@RequestParam(value = "name",required = true) String name,String company){
        if(name == null || name == ""){
            name="java";
        }
        String setKey = "testSet";
        redisTemplate.opsForSet().add(setKey, name);

        Set<String> resultSet = redisTemplate.opsForSet().members(setKey);
        System.out.println(setKey+" >>"+resultSet);
        boolean memberStatus = redisTemplate.opsForSet().isMember(setKey,company);
        System.out.println("memberStatus>>"+memberStatus);
//        redisTemplate.expire(setKey,2, TimeUnit.HOURS);
        redisTemplate.expire(setKey,2, TimeUnit.MINUTES);
        //根据key获取过期时间
        System.out.println("过期时间>>"+redisTemplate.getExpire(setKey));

        setKey = "farm_earmark_online_101_2022-03-02";
        Set<String> resultSet2 = redisTemplate.opsForSet().members(setKey);
        System.out.println(setKey+" members >>"+resultSet2);

        setKey = "farm_earmark_online_101_2022-03-02";
        boolean memberStatus2 = redisTemplate.opsForSet().isMember(setKey,company);
        System.out.println(setKey+" isMember >>"+memberStatus2);

        String hashKey = BizConst.FARM_ALL_STATUS_PREFIX+"101";
        System.out.println("hashKey>>>>>>>>>>>>>>>>>>>>>>>>"+hashKey);
        Map allMap = redisTemplate.opsForHash().entries(hashKey);
        System.out.println("allMap>>>>>>>>>>>>>>>>>>>>>>>>>"+allMap.toString());
        if(allMap.size()==0){
            System.out.println("==0");
        }else{
            System.out.println("!=0");
        }

    }
}
