package com.huimv.eartag2.producer;

import com.huimv.eartag2.common.mq.Const;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
public class Producer {
    @Autowired
    RabbitTemplate rabbitTemplate;  //使用RabbitTemplate,这提供了接收/发送等等方法

    /**
     * @Method      : saveRawdata
     * @Description : 保存原始数据到rabbitmq
     * @Params      : [askText]
     * @Return      : java.lang.String
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/2/8
     * @Time        : 17:39
     */
    public String sendClientAsk(String askText){
        Map map = new HashMap();
        System.out.println("000000000000000000 >>"+askText);
        map.put("askText",askText);
        map.put("test","askText2222222");
        System.out.println("111111111111111111>>"+map.toString());
//        rabbitTemplate.convertAndSend("askExchange", "topic.askText.key", map);
        rabbitTemplate.convertAndSend(Const.EXCHANGE_ASK, Const.ROUTING_KEY_ASK, map);
        System.out.println("保存原始数据到rabbitMQ>>"+map.toString());
        return "ok";
    }
}
